use async_trait::async_trait;
use rear::depot::prelude::*;
use serde_json::Value;

struct Repository {}

impl Repository {}

#[async_trait]
impl DepotRepository for Repository {
    type Key = i64;

    fn key_from_string(&self, s: String) -> Option<Self::Key> {
        if let Ok(i) = s.parse::<i64>() {
            Some(i)
        } else {
            None
        }
    }

    async fn info(&self, _: &RepositoryContext) -> RepositoryInfo {
        RepoInfo {
            name: "My Empty Repository",
            lookup_key: "id",
            display_list: &["id"],
            fields: &[],
        }
        .into()
    }

    // GET on item collection.
    async fn list(&self, model: &RepositoryContext) -> RepositoryList {
        RepositoryList::Empty
    }

    // POST on item collection.
    async fn create(&mut self, model: &RepositoryContext, mut data: Value) -> RepositoryResult {
        Ok(RepositoryResponse::NoItem)
    }

    // GET single item.
    async fn get(&self, model: &RepositoryContext, id: &Self::Key) -> RepositoryResult {
        Ok(RepositoryResponse::NoItem)
    }

    // PATCH single item.
    async fn update(
        &mut self,
        model: &RepositoryContext,
        id: &Self::Key,
        data: Value,
    ) -> RepositoryResult {
        Ok(RepositoryResponse::NoItem)
    }

    // PUT single item.
    async fn replace(
        &mut self,
        model: &RepositoryContext,
        id: &Self::Key,
        data: Value,
    ) -> RepositoryResult {
        Ok(RepositoryResponse::NoItem)
    }

    // DELETE single item.
    async fn delete(&mut self, _: &RepositoryContext, id: &Self::Key) -> Option<Value> {
        None
    }
}
